/*
Okta Admin Management

Allows customers to easily access the Okta Management APIs

Copyright 2018 - Present Okta, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

API version: 2024.06.1
Contact: devex-public@okta.com
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.
package okta

import (
	"encoding/json"
)

// AuthenticatorKeyDuoAllOfProvider struct for AuthenticatorKeyDuoAllOfProvider
type AuthenticatorKeyDuoAllOfProvider struct {
	// Provider type
	Type *string `json:"type,omitempty"`
	Configuration *AuthenticatorKeyDuoAllOfProviderConfiguration `json:"configuration,omitempty"`
	AdditionalProperties map[string]interface{}
}

type _AuthenticatorKeyDuoAllOfProvider AuthenticatorKeyDuoAllOfProvider

// NewAuthenticatorKeyDuoAllOfProvider instantiates a new AuthenticatorKeyDuoAllOfProvider object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAuthenticatorKeyDuoAllOfProvider() *AuthenticatorKeyDuoAllOfProvider {
	this := AuthenticatorKeyDuoAllOfProvider{}
	return &this
}

// NewAuthenticatorKeyDuoAllOfProviderWithDefaults instantiates a new AuthenticatorKeyDuoAllOfProvider object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAuthenticatorKeyDuoAllOfProviderWithDefaults() *AuthenticatorKeyDuoAllOfProvider {
	this := AuthenticatorKeyDuoAllOfProvider{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *AuthenticatorKeyDuoAllOfProvider) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthenticatorKeyDuoAllOfProvider) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *AuthenticatorKeyDuoAllOfProvider) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *AuthenticatorKeyDuoAllOfProvider) SetType(v string) {
	o.Type = &v
}

// GetConfiguration returns the Configuration field value if set, zero value otherwise.
func (o *AuthenticatorKeyDuoAllOfProvider) GetConfiguration() AuthenticatorKeyDuoAllOfProviderConfiguration {
	if o == nil || o.Configuration == nil {
		var ret AuthenticatorKeyDuoAllOfProviderConfiguration
		return ret
	}
	return *o.Configuration
}

// GetConfigurationOk returns a tuple with the Configuration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthenticatorKeyDuoAllOfProvider) GetConfigurationOk() (*AuthenticatorKeyDuoAllOfProviderConfiguration, bool) {
	if o == nil || o.Configuration == nil {
		return nil, false
	}
	return o.Configuration, true
}

// HasConfiguration returns a boolean if a field has been set.
func (o *AuthenticatorKeyDuoAllOfProvider) HasConfiguration() bool {
	if o != nil && o.Configuration != nil {
		return true
	}

	return false
}

// SetConfiguration gets a reference to the given AuthenticatorKeyDuoAllOfProviderConfiguration and assigns it to the Configuration field.
func (o *AuthenticatorKeyDuoAllOfProvider) SetConfiguration(v AuthenticatorKeyDuoAllOfProviderConfiguration) {
	o.Configuration = &v
}

func (o AuthenticatorKeyDuoAllOfProvider) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Type != nil {
		toSerialize["type"] = o.Type
	}
	if o.Configuration != nil {
		toSerialize["configuration"] = o.Configuration
	}

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return json.Marshal(toSerialize)
}

func (o *AuthenticatorKeyDuoAllOfProvider) UnmarshalJSON(bytes []byte) (err error) {
	varAuthenticatorKeyDuoAllOfProvider := _AuthenticatorKeyDuoAllOfProvider{}

	err = json.Unmarshal(bytes, &varAuthenticatorKeyDuoAllOfProvider)
	if err == nil {
		*o = AuthenticatorKeyDuoAllOfProvider(varAuthenticatorKeyDuoAllOfProvider)
	} else {
		return err
	}

	additionalProperties := make(map[string]interface{})

	err = json.Unmarshal(bytes, &additionalProperties)
	if err == nil {
		delete(additionalProperties, "type")
		delete(additionalProperties, "configuration")
		o.AdditionalProperties = additionalProperties
	} else {
		return err
	}

	return err
}

type NullableAuthenticatorKeyDuoAllOfProvider struct {
	value *AuthenticatorKeyDuoAllOfProvider
	isSet bool
}

func (v NullableAuthenticatorKeyDuoAllOfProvider) Get() *AuthenticatorKeyDuoAllOfProvider {
	return v.value
}

func (v *NullableAuthenticatorKeyDuoAllOfProvider) Set(val *AuthenticatorKeyDuoAllOfProvider) {
	v.value = val
	v.isSet = true
}

func (v NullableAuthenticatorKeyDuoAllOfProvider) IsSet() bool {
	return v.isSet
}

func (v *NullableAuthenticatorKeyDuoAllOfProvider) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuthenticatorKeyDuoAllOfProvider(val *AuthenticatorKeyDuoAllOfProvider) *NullableAuthenticatorKeyDuoAllOfProvider {
	return &NullableAuthenticatorKeyDuoAllOfProvider{value: val, isSet: true}
}

func (v NullableAuthenticatorKeyDuoAllOfProvider) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuthenticatorKeyDuoAllOfProvider) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

